import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';

import isNullOrEmpty from '../../utils/isNullOrEmpty';

import { datepickerShape } from './utils/propTypes';


export default ({
    block,
    Component
}) => {

    invariant(block !== undefined, 'Missing purebem block');
    invariant(Component !== undefined, 'Missing Datepicker component');

    return React.createClass({

        displayName: `${Component.displayName}Range`,

        mixins: [PureRenderMixin],

        propTypes: {
            actionTypePrefix: PropTypes.string,
            customActionMetadata: PropTypes.object,
            path: PropTypes.string,
            root: PropTypes.string,
            end: PropTypes.shape(datepickerShape),
            start: PropTypes.shape(datepickerShape)
        },

        render() {
            const { actionTypePrefix, customActionMetadata, path, root, start, end } = this.props;
            return (
                <div className={ block() }>
                    <Component
                        { ...start }
                        actionTypePrefix={ isNullOrEmpty(actionTypePrefix) ? actionTypePrefix : `${actionTypePrefix}-START` }
                        customActionMetadata={ customActionMetadata }
                        path={ `${path}.start` }
                        root={ root } />
                    <span className={ block('separator') }>&#65293;</span>
                    <Component
                        { ...end }
                        actionTypePrefix={ isNullOrEmpty(actionTypePrefix) ? actionTypePrefix : `${actionTypePrefix}-END` }
                        customActionMetadata={ customActionMetadata }
                        path={ `${path}.end` }
                        root={ root } />
                </div>
            );
        }

    });

};
